Package org.apache.commons.math3.ode.nonstiff

# Class DormandPrince54Integrator

java.lang.Object
org.apache.commons.math3.ode.AbstractIntegrator
org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeIntegrator
org.apache.commons.math3.ode.nonstiff.EmbeddedRungeKuttaIntegrator
org.apache.commons.math3.ode.nonstiff.DormandPrince54Integrator

All Implemented Interfaces:
  `FirstOrderIntegrator`, `ODEIntegrator`

public class DormandPrince54Integrator extends EmbeddedRungeKuttaIntegrator
This class implements the 5(4) Dormand-Prince integrator for Ordinary Differential Equations.

This integrator is an embedded Runge-Kutta integrator of order 5(4) used in local extrapolation mode (i.e. the solution is computed using the high order formula) with stepsize control (and automatic step initialization) and continuous output. This method uses 7 functions evaluations per step. However, since this is an fsal, the last evaluation of one step is the same as the first evaluation of the next step and hence can be avoided. So the cost is really 6 functions evaluations per step.

This method has been published (whithout the continuous output that was added by Shampine in 1986) in the following article :

      A family of embedded Runge-Kutta formulae
      J. R. Dormand and P. J. Prince
      Journal of Computational and Applied Mathematics
      volume 6, no 1, 1980, pp. 19-26

Since:
  1.2

## Field Summary

### Fields inherited from class org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeIntegrator

`mainSetDimension, scalAbsoluteTolerance, scalRelativeTolerance, vecAbsoluteTolerance, vecRelativeTolerance`

### Fields inherited from class org.apache.commons.math3.ode.AbstractIntegrator

`isLastStep, resetOccurred, stepHandlers, stepSize, stepStart`

## Constructor Summary

Constructors
Constructor
Description
`DormandPrince54Integrator(double minStep, double maxStep, double[] vecAbsoluteTolerance, double[] vecRelativeTolerance)`
Simple constructor.
`DormandPrince54Integrator(double minStep, double maxStep, double scalAbsoluteTolerance, double scalRelativeTolerance)`
Simple constructor.

## Method Summary

Modifier and Type
Method
Description
`protected double`
`estimateError(double[][] yDotK, double[] y0, double[] y1, double h)`
Compute the error ratio.
`int`
`getOrder()`
Get the order of the method.

### Methods inherited from class org.apache.commons.math3.ode.nonstiff.EmbeddedRungeKuttaIntegrator

`getMaxGrowth, getMinReduction, getSafety, integrate, setMaxGrowth, setMinReduction, setSafety`

### Methods inherited from class org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeIntegrator

`filterStep, getCurrentStepStart, getMaxStep, getMinStep, initializeStep, resetInternalState, sanityChecks, setInitialStepSize, setStepSizeControl, setStepSizeControl`

### Methods inherited from class org.apache.commons.math3.ode.AbstractIntegrator

`acceptStep, addEventHandler, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, computeDerivatives, getCounter, getCurrentSignedStepsize, getEvaluations, getEvaluationsCounter, getEventHandlers, getExpandable, getMaxEvaluations, getName, getStepHandlers, initIntegration, integrate, setEquations, setMaxEvaluations, setStateInitialized`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### DormandPrince54Integrator

public DormandPrince54Integrator(double minStep, double maxStep, double scalAbsoluteTolerance, double scalRelativeTolerance)
Simple constructor. Build a fifth order Dormand-Prince integrator with the given step bounds

Parameters:
  `minStep` - minimal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
  `maxStep` - maximal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
  `scalAbsoluteTolerance` - allowed absolute error
  `scalRelativeTolerance` - allowed relative error

### DormandPrince54Integrator

public DormandPrince54Integrator(double minStep, double maxStep, double[] vecAbsoluteTolerance, double[] vecRelativeTolerance)
Simple constructor. Build a fifth order Dormand-Prince integrator with the given step bounds

Parameters:
  `minStep` - minimal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
  `maxStep` - maximal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
  `vecAbsoluteTolerance` - allowed absolute error
  `vecRelativeTolerance` - allowed relative error

## Method Details

### getOrder

public int getOrder()
Get the order of the method.

Specified by:
  `getOrder` in class `EmbeddedRungeKuttaIntegrator`
Returns:
  order of the method

### estimateError

protected double estimateError(double[][] yDotK, double[] y0, double[] y1, double h)
Compute the error ratio.

Specified by:
  `estimateError` in class `EmbeddedRungeKuttaIntegrator`
Parameters:
  `yDotK` - derivatives computed during the first stages
  `y0` - estimate of the step at the start of the step
  `y1` - estimate of the step at the end of the step
  `h` - current step
Returns:
  error ratio, greater than 1 if step should be rejected